Deploy TemplateStyles to WMF production
Open, NormalPublic

Description

Deploying TemplateStyles to production would give a lot more power to our template editors to create experiences that are optimised for mobile.
See the subtasks for the various things that need to be resolved before this work can be finalised.

Related Objects

StatusAssignedTask
DuplicateNone
OpenNone
OpenNone
StalledNone
OpenNone
OpenNone
ResolvedJdlrobson
DuplicateNone
DuplicateNone
OpenNone
ResolvedTheDJ
ResolvedTheDJ
OpenNone
OpenNone
ResolvedTheDJ
OpenNone
ResolvedJdlrobson
OpenJdlrobson
OpenNone
OpenJdlrobson
OpenTgr
ResolvedAnomie
Resolvedtstarling
ResolvedAnomie
ResolvedAnomie
ResolvedEsanders
ResolvedEsanders
ResolvedAnomie
ResolvedCKoerner_WMF
Resolvedjhsoby
ResolvedTgr
DeclinedTgr
Resolvedcoren
ResolvedTgr
StalledZoranzoki21
ResolvedTgr
ResolvedDeskana
OpenZoranzoki21
ResolvedTgr
ResolvedUrbanecm
OpenTgr
ResolvedTacsipacsi
There are a very large number of changes, so older changes are hidden. Show Older Changes
Tgr claimed this task.Jan 9 2018, 5:52 PM
Isarra added a subscriber: Isarra.Jan 17 2018, 8:37 PM

So when's this happening? Wheeeeeen?

Hi @Isarra , just wanted to note that @Deskana is taking on product owner duties on this and is working with @Tgr around initial deployment needs. In brief, I think we're hoping to cover a wiki or two this current quarter, but it's best if @Deskana and @Tgr speak to it.

Hi @Isarra , just wanted to note that @Deskana is taking on product owner duties on this and is working with @Tgr around initial deployment needs. In brief, I think we're hoping to cover a wiki or two this current quarter, but it's best if @Deskana and @Tgr speak to it.

Speaking not on behalf of the community but I am pretty sure that dewiki would like to be in the next deployement round. cc/ @MartinK

If we want to propose specific projects for this, should we just do the usual discussion on-wiki to see if there's consensus, as it looks like svwiki has already done? Is there anything in particular people should know when discussing it? What would the timeframe look like to editors?

Iniquity added a subscriber: Iniquity.EditedJan 17 2018, 10:34 PM

@Isarra we are waiting for T180817 this task.

I don't want deployment of TemplateStyles to be a moving target—as it has been for many months—so I'm going to stick to the plan to deploy to only svwiki as the first phase. That will be done some time after T176268 and T176269 are complete.

To be included in the second phase—which right now is just ruwiki—getting a consensus on-wiki for deployment is a good step. To be clear though, I may decide to delay deployment for a wiki to a later phase even if a consensus exists if I think it might jeopardise the deployment plan.

Slow and steady wins the race. :-)

Anomie added a comment.EditedJan 18 2018, 4:01 PM

@Isarra we are waiting for T180817 this task.

Regarding that, see T180817#3770716. Deduplication wasn't supposed to block TemplateStyles deployment.

I don't want deployment of TemplateStyles to be a moving target—as it has been for many months—so I'm going to stick to the plan to deploy to only svwiki as the first phase. That will be done some time after T176268 and T176269 are complete.

I still think T176269 is a bad idea and should be declined. So, it seems, do most others who've comment there:

  • In favor: Deskana (by proxy, hasn't commented there), tgr, Iniquity (although possibly more for T177027 than that task)
  • Opposed: anomie, Nirmos, Legoktm, stjn, Platonides
  • Comments, but no opinion on that task expressed: Bawolff, dr0ptp4kt, IKhitron, Jdlrobson (expressed support for something more like T177027 than this task)

That's 5 opposed, 2 or 3 supporting, and 4 or 5 without an opinion on the issue at hand that I could identify.

IMO T176268 is probably pointless but it's simple enough that if Gergő wants to do it I don't care enough to argue over it.

Slow and steady wins the race. :-)

The "slow" part certainly does seem to be the case here.

Tgr added a comment.Jan 19 2018, 2:37 AM

Sorry for taking so long on this :( Somehow it managed to be #2 on my todo list for a very long time, with various other things always taking priority.

I still think T176269 is a bad idea and should be declined.

I don't have much opinion on the idea itself either way but after trying to do the implementation I think I agree it would be better to go without it. I don't see a way to do it without interacting with parser frames which are entirely undocumented and one of the more complex parts of the MediaWiki codebase, so depending on them would probably make a deployment more risky, not less.

debt added a subscriber: debt.Jan 20 2018, 12:23 AM
Isarra added a comment.EditedJan 20 2018, 6:36 PM

I don't want deployment of TemplateStyles to be a moving target—as it has been for many months—so I'm going to stick to the plan to deploy to only svwiki as the first phase.

Well, that's disappointing.

Why would including any others that pile up make it any worse, though?

ggellerman moved this task from Up next to External on the TemplateStyles board.Feb 27 2018, 6:55 PM
Tgr added a comment.Feb 28 2018, 2:49 AM

As @Anomie noted there, T186965: Output HTML should not contain `<p><style>...</style></p>` is fixed (or will be once the patch is merged) for wikis using Remex but not for ones using Tidy (there a <templatestyles> tag in the middle of a paragraph will break it into two paragraphs), so switching to Remex should be a blocker for deploying TemplateStyles. (Tracking task: T175706: Progressively switch Wikimedia wikis from Tidy to RemexHTML. Search for wgTidyConfig here to see the current state; the ones with a null line still use Tidy.) Swedish and Russian have already switched so this has no immediate impact on plans.

This comment was removed by Anomie.
Krinkle removed a subscriber: Krinkle.
Tgr changed the status of subtask T189022: Deploy TemplateStyles to zhwiki from Open to Stalled.
Tgr added a comment.Mar 16 2018, 8:02 AM

Quick overview of the open technical tasks:

  • On Parsoid (currently this means VE, Flow, the mobile apps and whatever third parties use the REST API) if the <templatestyles/> tag is on its own line it will result in an empty paragraph (and consequently weird spacing). Needs a Parsoid change; would be nice to get it fixed.

That depends on the specific styles that apply to <p> tags. In Firefox 52.6.0 the <p> tag in question seems to collapse to 0 height in all skins on enwiki in a simple test, no weird spacing observed.

Tgr added a comment.Mar 16 2018, 6:18 PM

That depends. Try something like this:

<div style="height:10px; border:1px solid black;"></div>
<p></p>
<div style="height:10px; border:1px solid black;"></div>

The two divs should touch but won't.

A <p> with no content adds an empty box with 14px margin (on Vector, anyway); if the neighboring elements have at least that much margin (e.g. they are also paragraphs) the margins will collapse and there will be no change at all. Otherwise there will be some extra empty space.

Certainly a very fringe problem though.

Hi,
happy holidays! I have question. How to we fix tags so migration can be faster?

As @Anomie noted there, T186965: Output HTML should not contain `<p><style>...</style></p>` is fixed (or will be once the patch is merged) for wikis using Remex but not for ones using Tidy (there a <templatestyles> tag in the middle of a paragraph will break it into two paragraphs), so switching to Remex should be a blocker for deploying TemplateStyles. (Tracking task: T175706: Progressively switch Wikimedia wikis from Tidy to RemexHTML. Search for wgTidyConfig here to see the current state; the ones with a null line still use Tidy.) Swedish and Russian have already switched so this has no immediate impact on plans.

Not sure I understand your question. Are you asking how to fix the lint errors so that wikis can switch from Tidy to Remex? In that case, there is plenty of information on https://www.mediawiki.org/wiki/Help:Extension:Linter and its subpages.

Hi,
happy holidays! I have question. How to we fix tags so migration can be faster?

As @Anomie noted there, T186965: Output HTML should not contain `<p><style>...</style></p>` is fixed (or will be once the patch is merged) for wikis using Remex but not for ones using Tidy (there a <templatestyles> tag in the middle of a paragraph will break it into two paragraphs), so switching to Remex should be a blocker for deploying TemplateStyles. (Tracking task: T175706: Progressively switch Wikimedia wikis from Tidy to RemexHTML. Search for wgTidyConfig here to see the current state; the ones with a null line still use Tidy.) Swedish and Russian have already switched so this has no immediate impact on plans.

Hey there. Assuming you're talking about the switch to Remex, you can see https://www.mediawiki.org/wiki/Parsing/Replacing_Tidy/FAQ#What_will_editors_need_to_do? . You can ask any followup questions on the talk page there. At T190731 you'll see the list of the wikis whose switch is happening next week.

Izno added a subscriber: Izno.Apr 18 2018, 12:53 AM
Qgil removed a subscriber: Qgil.Mon, Jun 18, 4:23 PM
cscott added a subscriber: cscott.Thu, Jul 5, 4:14 PM

As @Anomie noted there, T186965: Output HTML should not contain `<p><style>...</style></p>` is fixed (or will be once the patch is merged) for wikis using Remex but not for ones using Tidy (there a <templatestyles> tag in the middle of a paragraph will break it into two paragraphs), so switching to Remex should be a blocker for deploying TemplateStyles. (Tracking task: T175706: Progressively switch Wikimedia wikis from Tidy to RemexHTML. Search for wgTidyConfig here to see the current state; the ones with a null line still use Tidy.) Swedish and Russian have already switched so this has no immediate impact on plans.

Shouldn't this be mentioned on https://www.mediawiki.org/wiki/Extension:TemplateStyles#Configuration (or #Caveats)?

Ladsgroup changed the status of subtask T191452: Deploy TemplateStyles on French Wikipedia from Stalled to Open.Wed, Jul 11, 3:06 PM